
#define Version "17-04-2016"

//   modif bootloader Q=10MHz x 4 PLL => 40MHz  
// UART speed -> 57600    speed error 0,22%
/*
TinybldWin98.exe sur PC XP
Tiny Bootloader :
sur PC XP
liaison COM1 avec platine 18F Nokia via rajout cable DB9F-DB9F
C:\_Mplab8\tinybldWin198.exe
\\Asus_cm6431\_18F4685_Platine_Nokia\18F4685_Nokia_96x64_8x16_Librarie_test_2016.hex

Connected to \\.\COM1 at 57600
  Wait 100ms
  HEX: 12 min old, INHX32,18Fcode+cfg, total=10637 bytes.
  Searching for PIC ...Not found,
  ERROR!

Connected to \\.\COM1 at 57600
  Wait 100ms
  HEX: 14 min old, INHX32,18Fcode+cfg, total=10637 bytes.
  Searching for PIC ...
  Found:18F 4685
  WRITE OK  at 19:20,   time:5.235 sec

16:21:03.843> Vecteur Start Bootloader en 0x17F38=  57EF2EF0
16:21:03.906> Adresse point d'entree Prg MikroC = 2e57 h mutiplie 2 soit 5cae  ou  23726 decimal
*/
// modif routines EEPROM car taille 1024 au lieu de 256
//20/03/2016
// TinybldWin98.exe

// problemo avc TinyBootloader 1.98: L'eeprom est limite en taille 256 maxi
// donc ne charge pas au dela pour EEPROM de 1024
//  rappel : sur la platine Nokia  mettre le stap ref 4.096V sur AN3 !

#define Projet "18F4685_Platine_Nokia_Test_BMP_2016_40Mhz.mcppi"
#define Source  "18F4685_Platine_Nokia_test_BMP_96x64_160417.c"

 // schema :   ac:schema
 
 // photo       ac:photo_realisation
 
  // Pinout  :     ac:Pinout
 

// rajout Cde RAZ Index eeprom
// modif Index relecture pour 1  xxxx au lieu de 0  xxx
// suite division par 2 bytes pour chaque Int mesure ADC
// modif DiplayDate   affiche 23 pour jour 29 sur UARTT mais OK sur LCD
// enlev conversion BCcd2dec
// DateTime[1]=Mois;ByteToStr( Mois,CRam1); UART1_Write_Text( CRam1); UART1_Write('/'); 
//  was DateTime[1]=Mois;ByteToStr( Bcd2Dec(Mois),CRam1); UART1_Write_Text( CRam1); UART1_Write('/'); 


// Config touches de fonction terminal VBRAY
// 16f877_platine_nokia_rs.tmf
// Hardware:
// Platine 18F4685 96Ko equipee Nokia  + I2C + 2 x PCF8574 + 24LC256 + DS1307 + DS275
// LCD nokia 3310 8 lignes de 16 car
// Q=10Mhz
// config:
// 18F4685_Q10Mhz.cfgsch
/*
CONFIG1H : $300001 : 0x0002
CONFIG2L : $300002 : 0x001F
CONFIG2H : $300003 : 0x001E
CONFIG3H : $300005 : 0x0082
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x003F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x003F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x003F
CONFIG7H : $30000D : 0x0040
 */

// 17-06-2014
// rajout gestion 24LC256
// cdes terminal
// STA<CR> start stockage sur EEprom  Index raz!
// HAL<CR> HALte sauve sur eerprom  (Index NON raz!) 
// REL<CR> Stope stockage et Relit (liste) contenu Eeprom  
// DUM<CR> dump Flash du PIC

//
//U;16;06;14;1;19;35#
//Mise a l'heure RTC
//Time:  13: 23:  0        ADC0=   442        ADC1=  1020
//Time:  13: 23:  2        ADC0=   442        ADC1=

// 14-06-2014
// CONFIG   :$2007 : 0x1B12  Flash programm over 0x10000 protegee
// des que j'initialise I2C ,plus d'affichage LCD !!!
// HORREUR ! le piege : c'est en I2C Software que la platine est prevue (car au depart 100% Asm)
// et RC3 RC4 sont utiliss en SPI pour le nokia .. 
// I2C SOFTWARE sur RB7=SCL et RB6=SDA

/*
Version  XPORT-Archos43it RFObasic 
 en MPLAB 100% asm rev 28/02/2011  
 Platine_16F877_nokia_Xport_Archos_120228.asm 
<H>elp
<1>Consigne 1
<2>Consigne 2
<3>Consigne 3
<L>ecture PCF
<E>critur PCF
<U>pdate RTC
------
*/
//#14/06/14 18H51M32S;A1=0793 ;A2=0305 ;A3=0293 ;A4=0279 ;A5=0271 ;L=00000001=01h;R=00100010=22h;&
//Version Ldd_Chr en conflit avec LCD biblio => desactivee

// 13-06-2014
// Ne pas utiliser la biblio ADC Mickroc
// qui ne gere pas le cas de Vref specifique 
// rajout bragraph nokia

 //==== Parametrage pour RS232 ====
#define FOSC D'40000000'        ; <<< frequence du quartz[Hz]  ici= 10 MHz
#define BAUD D'57600'           ; <<< vitesse du port serie [bit/sec] ici=19200
#define BAUD_ERROR D'4'; <<< erreur de vitesse [%]
#define TIMEOUT  D'10'
#define BAUD_REAL   FOSC/((D'64'-(HIGH_SPEED*D'48'))*(DIVIDER+1))

#define RS232 1
#define Nokia 0

#define Limite_Max_Flash 0x17F36
//-- compilations conditionnelles -----
#define EEPROM_PIC_1024
#define EEPROM_24LC512
#define Dump
#define Software_I2C   
#define DS1307 0xD0

#define NOIR 1
#define      BLANC         0
#define      COMPRIME     1  // Font 3x6
#define      NORMAL       2  // Font 5x7
#define      LARGE        0  // Font 7x8

//#define EEPROM_64K_ADR 0xA0   // EEPROM 24LC512
// pins 1,2,3  Adresse bits =0  => to Gnd
// 4 = VSS= 0V=Gnd
// 7= WP = Write Protect =


//  Nokia LCD
//  pin support LCD Nokia  1 .. 8  sur connecteur Blanc Platine  pins 1 .. 8
/*
#define D_C PORTC.B1
#define SCE PORTC.B0
#define RES PORTC.B2
#define SCK PORTC.B3
#define SDI PORTC.B4
*/

// pour RTC DS1307 + PCF8574
// Software I2C  cause interference abec LCD nokia
#ifdef Software_I2C       
sbit Soft_I2C_Scl           at RB6_bit;
sbit Soft_I2C_Sda           at RB7_bit;
sbit Soft_I2C_Scl_Direction at TRISB6_bit;
sbit Soft_I2C_Sda_Direction at TRISB7_bit;
sbit INIT_RTC               at RB1_bit;
// pour garder la syntaxe I2C Hardware
#define I2C1_Start()    Soft_I2C_Start()
#define I2C1_Wr         err=Soft_I2C_Write
#define I2C1_Stop       Soft_I2C_Stop
#define I2C1_Rd         Soft_I2C_Read
#endif
 
#define LedVerte PORTE.F0
#define LedBlanche PORTE.F1
#define LedRouge PORTE.F2
#define Pi 3.14159 // Constant Pi.
#define num_of_points 64 // Number of points to plot in a graph.

#define CLS 12
#define CR 13
#define LF 10
#define BS 8
#define TAB 9

const code char mesg0[]="MikroC 18F4685 avec Bootloader Platine PF  16-04-2016\r\n";
const code char mesg1[]="RTC+UART+I2C+PCF8574+24LC256+Nokia3310 Q=10Mhz x PLL=40MHz\n\r";
const code char * Messages[]={mesg0,mesg1};
const code char JS[8][6] ={"Diman","Lundi","Mardi","Mercr","Jeudi","Vendr","Samed"};

// ------------------------------------------------------
// Picture name: mikroE96x64_bmp
// GLCD Model: Nokia3310 Like
// ------------------------------------------------------
unsigned char const mikroE96x64_bmp[768] = {
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0, 255, 255, 255,   0, 255, 255, 255,  15,  15,
195, 195, 195, 195, 195, 195, 195, 195, 207, 207,  15,  31,
255, 255, 255, 255,  63,  63,  31,  31,  15,  15,  15,   3,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,  15,  15,
 15,  31,  31,  63,  63,  63, 255, 255, 255, 255, 255, 255,
255, 255, 255,   0, 255, 255,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0, 255, 255, 255,   0, 255, 255, 255, 240, 225,
225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 240, 254,
 31,   3,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0, 192, 240, 240, 240, 224,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   3,  15, 255, 255, 255,
255, 255, 255,   0, 255, 255,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0, 255, 255, 255,   0, 255, 255, 255, 192, 192,
192, 192, 193, 195, 195, 195, 195, 195, 255, 255, 255, 255,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,  63, 255, 255, 255, 255,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 255, 255,
255, 255, 255,   0, 255, 255,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0, 255, 255, 255,   0, 255, 255, 255,  16,  49,
  1,   1,   1,  15,   3,   1,   1,  16, 255, 255, 255, 255,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 255, 255,
255, 255, 255,   0, 255, 255,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0, 255, 255, 255,   0, 255, 255, 255,  12, 254,
 62,  62,  14,  14,  14,  14,  14,  14, 255, 255, 255, 255,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0, 254, 255, 255, 255, 255, 255,  15,  15,  15,  15,
 15,  15,  15,  15,  15,  15,  15,  15,  15,  15, 255, 255,
255, 255, 255,   0, 255, 255,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0, 255, 255, 255,   0, 255, 255, 255,   3, 195,
195, 195, 195, 195, 195, 195, 195, 195, 223, 223, 255, 255,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0, 255, 255, 255, 255, 255, 255,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 255, 255,
255, 255, 255,   0, 255, 255,   0,   0,   0,   0,   0,   0,
  1,   0,   0,   0,  72, 166, 155,   6,  88,  22, 157,   6,
  1,   0,   0,   0,  72, 166, 155,   6,  88,  22, 157,   6,
192,  22, 157,   6,  40,  23, 157,   6, 144,  23, 157,   6,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
112, 248, 146,   6, 200,  50, 101,   0, 128, 210, 243,   2,
 24, 160, 170,   6,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   1,   0,   0,   0,  49, 237,  70,   0,
  0,   0,   0,   0,   1,   0,   0,   0,  49, 237,  70,   0,
 65, 237,  70,   0, 176,  20, 243,   2,   0,   0,   0,   0,
196,  54, 103,   0, 176,   6, 147,   6,   0,   0,   0,   0,
 50,   0,   0,   0,  19,   4,   0,   0, 187,   1,   0,   0,
202, 104,   0,   0,   0,   0,   0,   1,   1,   1,   0,   5,
  0,   0,   0,   0,   1,  15,   0,   0,   0,   0,   0,   0,
136,   8, 141,   6,   0,   0,   0,   0,   5,   0,   0, 255,
176,   8, 141,   6, 216,   8, 141,   6,   0,   0, 244, 255
};

 unsigned char const image_MikroE96x64[768] = {
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0xff, 0x00, 0x01, 0xff, 0xc0, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0xff, 0x00, 0x01, 0xff, 0xc0, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe0, 0x0f, 0xff, 0xf8, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xf0, 0x3f, 0xff, 0xfe, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0x00, 0x30, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0x00, 0x30, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x33, 0xff, 0xff, 0xff, 0xe0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe3, 0xff, 0xff, 0xff, 0xe0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xff, 0xff, 0xf0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xff, 0xff, 0xf0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x21, 0xff, 0xc7, 0xff, 0xe3, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc1, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc1, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xc0, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xe0, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x01, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xe7, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xef, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xef, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0xfe, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xe0, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x0f, 0xff, 0xc0, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x3f, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x3f, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xcf, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xc7, 0xff, 0xe1, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xf7, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xf7, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe3, 0xff, 0xff, 0xff, 0xf0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x03, 0xff, 0xff, 0xff, 0xe0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xf8, 0xff, 0xff, 0xff, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xfc, 0x1f, 0xff, 0xfe, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xfe, 0x07, 0xff, 0xf8, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xfe, 0x07, 0xff, 0xf8, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x23, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x23, 0xff, 0xff
};


/*
 // avec paintuino  format Gamebuino

unsigned char mikroE96x64[] =
{
  0x00,0x01,0xDF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0x00,0xFF,0xFE,0x00,0x3F,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0x00,0xFF,0xFE,0x00,0x3F,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x1F,0xF0,0x00,0x07,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x0F,0xC0,0x00,0x01,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0xFF,0xCF,0x00,0x00,0x00,0x3F,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0xFF,0xCF,0x00,0x00,0x00,0x3F,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0xFF,0xCC,0x00,0x00,0x00,0x1F,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x1C,0x00,0x00,0x00,0x1F,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x18,0x00,0x00,0x00,0x0F,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x18,0x00,0x00,0x00,0x0F,0xEC,0x00,0x00,
  0x00,0x01,0xDE,0x00,0x38,0x00,0x1C,0x00,0x07,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xF0,0x00,0x1E,0x00,0x07,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xF0,0x00,0x3E,0x00,0x07,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xF0,0x00,0x3E,0x00,0x07,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x3F,0xF0,0x00,0x3E,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x1F,0xF0,0x00,0x3E,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0xF0,0x00,0x3E,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0xF0,0x00,0x3E,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0xF0,0x00,0x3E,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0xF0,0x00,0x3E,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xF0,0x00,0x1E,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xF0,0x00,0x1E,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0xFE,0xF0,0x00,0x00,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x18,0xF0,0x00,0x00,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x10,0xF0,0x00,0x00,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x10,0xF0,0x00,0x00,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0x01,0xF0,0x00,0x00,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0x00,0xF0,0x00,0x00,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0xF0,0x00,0x00,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0xF0,0x00,0x00,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0xF0,0x00,0x1F,0xFF,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0xFF,0xF0,0x00,0x3F,0xFF,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xF0,0x00,0x3F,0xFF,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xF0,0x00,0x3F,0xFF,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0xC0,0xF0,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0xC0,0xF0,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0x00,0xF0,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0x00,0xF0,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xF0,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xF0,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0xF0,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0xF0,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0xF0,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x30,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0xFF,0xF0,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0xFF,0xF0,0x00,0x3F,0x00,0x03,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xF0,0x00,0x1E,0x00,0x07,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x38,0x00,0x1E,0x00,0x07,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x18,0x00,0x08,0x00,0x07,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x18,0x00,0x08,0x00,0x07,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x1C,0x00,0x00,0x00,0x0F,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0xFF,0xFC,0x00,0x00,0x00,0x1F,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0xFF,0xFE,0x00,0x00,0x00,0x3F,0xEC,0x00,0x00,
  0x00,0x01,0xDD,0xFF,0xFE,0x00,0x00,0x00,0x3F,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x07,0x00,0x00,0x00,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x03,0xE0,0x00,0x01,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x01,0xF8,0x00,0x07,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDC,0x00,0x01,0xF8,0x00,0x07,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xEC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xDC,0x00,0x00,
  0x00,0x01,0xDF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xDC,0x00,0x00,
};
 */
 // use Paint shop pro 5 pour faire le BMP
 // et Patuino pour conversion en data C
 // supprimer les 2 premiers octets = taille image !
 unsigned char const  paulfjujo_1bit[] =
{
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x07,0xE0,0x00,0x00,0x00,0x87,0xFC,0x00,0x00,0x00,0x00,0x00,
  0x0F,0xF0,0x00,0x00,0x01,0xC7,0xFF,0x0E,0x00,0x01,0xC0,0x00,
  0x0F,0xF8,0x00,0x00,0x01,0xC7,0xFE,0x0E,0x00,0x01,0xC0,0x00,
  0x0E,0x3C,0x00,0x00,0x01,0xC7,0x00,0x0E,0x00,0x01,0xC0,0x00,
  0x0E,0x1C,0x00,0x00,0x01,0xC7,0x00,0x00,0x00,0x00,0x00,0x00,
  0x0E,0x1C,0x1E,0x04,0x11,0xC7,0x00,0x04,0x10,0x40,0x81,0xF0,
  0x0E,0x3C,0x3F,0x8E,0x39,0xC7,0xFC,0x0E,0x38,0xE1,0xC3,0xF8,
  0x0F,0xF8,0x7F,0x8E,0x39,0xC7,0xFE,0x0E,0x38,0xE1,0xC7,0xF8,
  0x0F,0xF0,0x73,0x8E,0x39,0xC7,0xFC,0x0E,0x38,0xE1,0xC7,0x3C,
  0x0F,0xE0,0xE3,0x8E,0x39,0xC7,0x00,0x0E,0x38,0xE1,0xCE,0x1C,
  0x0E,0x00,0xE3,0x8E,0x39,0xC7,0x00,0x0E,0x38,0xE1,0xCE,0x1C,
  0x0E,0x00,0xE3,0x8E,0x39,0xC7,0x00,0x0E,0x38,0xE1,0xCE,0x1C,
  0x0E,0x00,0xE3,0x8E,0x39,0xC7,0x00,0x07,0x38,0xE0,0xEE,0x1C,
  0x0E,0x00,0xE3,0x8E,0x39,0xC7,0x00,0x07,0x38,0xE0,0xEF,0x3C,
  0x0E,0x00,0x7F,0xCF,0xF9,0xC7,0x00,0x07,0x3F,0xE0,0xE7,0xF8,
  0x0E,0x00,0x7F,0xC7,0xF9,0xC7,0x00,0x07,0x1F,0xE0,0xE7,0xF0,
  0x04,0x00,0x3C,0xC3,0xF8,0x82,0x00,0xC7,0x0F,0xF8,0xE1,0xE0,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xE7,0x00,0x1C,0xE0,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF7,0x00,0x1E,0xE0,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x0F,0xE0,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x07,0xC0,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x03,0x80,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x00,
  0x00,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x01,0xF8,0x00,0x00,
  0x00,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x01,0xF0,0x00,0x00,
  0x00,0x00,0xF0,0x00,0x00,0x00,0x00,0x00,0x03,0xC0,0x00,0x00,
  0x00,0x00,0xE0,0x00,0x00,0x00,0x00,0x00,0x03,0x80,0x00,0x00,
  0x00,0x03,0xFC,0x77,0x83,0xE0,0x3E,0x00,0x0F,0xF1,0xDE,0x00,
  0x00,0x07,0xFE,0x7F,0xCF,0xF0,0xFF,0x00,0x1F,0xF9,0xFF,0x00,
  0x00,0x03,0xFC,0x7F,0xDF,0xF9,0xFF,0x80,0x0F,0xF1,0xFF,0x00,
  0x00,0x00,0xE0,0x7D,0xDC,0x39,0xC3,0x80,0x03,0x81,0xF7,0x00,
  0x00,0x00,0xE0,0x71,0xFC,0xFB,0xCF,0x80,0x03,0x81,0xC7,0x00,
  0x00,0x00,0xE0,0x70,0x3B,0xF3,0xBF,0x00,0x03,0x81,0xC0,0x00,
  0x00,0x00,0xE0,0x70,0x3F,0xC3,0xFC,0x00,0x03,0x81,0xC0,0x00,
  0x00,0x00,0xE0,0x70,0x3F,0x03,0xF0,0x00,0x03,0x81,0xC0,0x00,
  0x00,0x00,0xE0,0x70,0x3C,0x3B,0xC3,0x80,0x03,0x81,0xC0,0x00,
  0x01,0xC0,0xE0,0x70,0x1F,0xF9,0xFF,0x87,0x03,0x81,0xC0,0x00,
  0x01,0xC0,0xE0,0x70,0x0F,0xF0,0xFF,0x07,0x03,0x81,0xC0,0x00,
  0x01,0xC0,0xE0,0x20,0x07,0xE0,0x7E,0x07,0x03,0x80,0x80,0x00,
  0x00,0x00,0xE0,0x00,0x00,0x00,0x00,0x00,0x03,0x80,0x00,0x00,
  0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

 

//  use of 2bmp1bpp.exe
//  use of Paintuino.exe

unsigned char const  MikroC_Everywhere_96x64[] =
{
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x01,0xC3,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,
  0x00,0x00,0x00,0x01,0xC3,0x80,0x00,0x00,0x00,0x00,0xFF,0xC0,
  0x00,0x00,0x00,0x01,0xC3,0x80,0x00,0x00,0x00,0x01,0xFF,0xC0,
  0x00,0x00,0x00,0x01,0xC3,0x80,0x00,0x00,0x00,0x03,0xE0,0x00,
  0x00,0x00,0x00,0x00,0x03,0x80,0x00,0x00,0x00,0x03,0x80,0x00,
  0x00,0x00,0x00,0x00,0x03,0x80,0x00,0x00,0x00,0x03,0x80,0x00,
  0x00,0x07,0x06,0x00,0x03,0x80,0x00,0x60,0x38,0x07,0x00,0x00,
  0x00,0xFF,0xBF,0x81,0xC3,0x83,0x8F,0xE0,0xFE,0x07,0x00,0x00,
  0x00,0xFF,0xFF,0xC1,0xC3,0x87,0x8F,0xE1,0xFF,0x07,0x00,0x00,
  0x00,0xF9,0xF1,0xC1,0xC3,0x8F,0x0F,0x83,0xC7,0x87,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0x8E,0x0E,0x03,0x83,0x87,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0x9C,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xBC,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xF8,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xF0,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xE0,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xE0,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xF0,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xF8,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xB8,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xBC,0x0E,0x07,0x01,0xC7,0x80,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0x9E,0x0E,0x07,0x83,0xC3,0x80,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0x8E,0x0E,0x03,0x83,0x83,0xC0,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0x8F,0x0E,0x03,0xFF,0x81,0xFF,0xC0,
  0x00,0xE0,0xE0,0xE1,0xC3,0x87,0x8E,0x01,0xFF,0x00,0xFF,0xC0,
  0x00,0xC0,0xE0,0xE1,0xC3,0x03,0x8E,0x00,0xFE,0x00,0x7F,0xC0,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x01,0xFF,0x80,
  0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x4A,0x80,
  0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x4A,0x80,
  0x00,0x71,0x08,0xE2,0xB1,0xA0,0x27,0x83,0x8A,0x38,0x4A,0x80,
  0x00,0xF9,0x99,0xF3,0xF1,0xA2,0x37,0xC7,0xCE,0x7C,0x4A,0x80,
  0x00,0x8D,0x9B,0x33,0x31,0xA7,0x24,0x6C,0xCC,0xCC,0x4A,0x80,
  0x01,0x8D,0x9B,0x1A,0x11,0x37,0x64,0x6C,0x48,0xC6,0x42,0x00,
  0x01,0xFD,0x9B,0xFA,0x1B,0x37,0x64,0x6F,0xE8,0xFE,0x00,0x00,
  0x01,0xF8,0x93,0xF2,0x1B,0x35,0x64,0x6F,0xC8,0xFC,0x00,0x00,
  0x01,0x80,0xF3,0x02,0x1B,0x3D,0xE4,0x6C,0x08,0xC0,0x00,0x00,
  0x00,0xC0,0xF3,0x02,0x0E,0x3D,0xC4,0x6C,0x08,0xC0,0x00,0x00,
  0x00,0xFC,0xF1,0xF2,0x0E,0x1D,0xC4,0x67,0xC8,0x7C,0x00,0x00,
  0x00,0x78,0x60,0xF2,0x0E,0x18,0xC4,0x63,0xC8,0x3C,0x00,0x00,
  0x00,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};



#define MAXLEN 128
unsigned  char buffer1[MAXLEN] ;

unsigned char TEXTE[128];
unsigned char *txt;
unsigned char Page_Ram[64];
unsigned char c1,c2;
unsigned char CRam1[32];
unsigned char *CRam;

int Page_Count;
unsigned int AdrE;

char CRam0[16];
volatile int Index1, CptErr,i1;
volatile int count;
unsigned int i,j,k;
unsigned int ir,k1;
unsigned int Index;
long L;
unsigned int M,M0,M1;

char UnCar,err;
unsigned char Seconde, Minute, Heure, week_day, day, Mois, Annee;
unsigned char octet;
unsigned char DateTime[9];

volatile struct chbits {   // 8 flags
                 unsigned FrameErr:1;
                 unsigned Store:1;
                 unsigned Elligible:1;
                 unsigned Togle:1;            
                 unsigned Second;
                 unsigned See:1;
                 unsigned Full:1;
                 unsigned Lcd:1;
               }Drapeaux ;   
float F1;  

// -------- UART 1 ------------------------
void redirige_RS232(int wcr,unsigned char *T);
void Write_String(unsigned char *T);
void CRLF1(void);
void strConstRamCpy(unsigned char *dest, const code char *source);
unsigned char *Float2Ascii (float x, unsigned char *str,char precision);
void UART1_Write_CText(const char *txt); 
 
//---- EEPROM PIC  1024 bytes for 18F  ================
unsigned char EEPROM_Lect(int adrE) ; // lecture a l'adresse adrL
void EEPROM_Ecr(unsigned int adrE,unsigned char car); // ecrit  a l'adresse adrE
void Save_Msg_To_EEPROM(int * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(int PtrE);


void interrupt()
 {
   if ((RCIE_bit) && (RCIF_bit))
    {
       c1 = RCREG;
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;     // clear OERR flag
       RCSTA.CREN = 1 ;
       CptErr++;
       c1 = RCREG;          // empty buffer
       c1=0;
      } 
      else
       if(RCSTA.FERR==1 )
       {
        CptErr++;
        c1=0;
       } 
       else
       {
         c1 = RCREG;        // no errors
         if ((c1==CR) || (i1>=MAXLEN)) 
         {
           Drapeaux.Full=1;
            buffer1[i1]=0;
           Index1=i1;
           i1=0;
           c1=0;
         }
         else
         { 
           buffer1[i1]=c1;
           Index1=i1;
          i1++;
         }
       }
    }
     // ------ Timer0 --------------
    if ((T0IE_bit)&&(TMR0IF_bit))
     {
         TMR0IF_bit    = 0;
         TMR0H         = 0x67;
         TMR0L         = 0x69;
         Drapeaux.Elligible=1;
         Soft_I2C_Break();
      }
   #ifdef Use_Timer1
   // -- Timer1 --------------
    if ((TMR1IE_bit)&&(TMR1IF_bit))
      {  
         TMR1IF_bit    = 0;
        // TMR1H=Hi (Valeur);
        // TMR1L=Lo (Valeur);
         TMR1H= (3035 >> 8);
         TMR1L= (3035 & 0x00FF);
         //TMR1H=  0x0B; // 3035  init  100mS at 20Mhz
         //TMR1L=  0xDB;
         count1++;                  //Increase counter by one
      if (count1 >= 10)         //Adjust this value for different time (10ms x 100 = 1000ms or 1sec)
        {
         Drapeaux.Second=1;  
         count1 = 0;
         }
      }
   #endif     
   
   #ifdef Test_Timer2
   if((TMR2IE_bit) && (TMR2IF_bit))
        {
        LedRouge=~LedRouge;
         //     TXREG='*';    to see tha interrupt has occured on terminal UART
         TMR2=0;
        TMR2IF_bit=0;
       }
   #endif    
 }
 
 
 #include "MyLib_Nokia_8x16.h"

#ifdef Test_Timer2
 void Init_Timer2(void)
{        
        TMR2 = 0x00;
        //T2CON = 0x75;  // Prescaler 4, Postscaler 
        T2CON.TOUTPS0=0x0F; // 1:16 Postscale
        T2CON.T2CKPS0=3 ;  // Precaler= 16
        T2CON.TMR2ON=1; // Timer 2 ON
        
        T2CON=0b01111111; 
        TMR2IF_bit = 0;
        CCP1CON=0;
        TMR2IE_bit = 1;
        TMR2=0;
        PR2 = 0xFF;     
}
#endif


 #ifdef EEPROM_PIC_1024
//------  EEPROM 1024 du  PIC18F---------------

unsigned char EEPROM_Lect(unsigned int AdrL) // lecture a l'adresse adr
{
    EEADR =(unsigned char)(AdrL&0x00FF);
    EEADRH =(unsigned char) ((AdrL>>8)&0x0003);   //Bits 2-7 are masked off since EEPROM is only 1KB
        EECON1.EEPGD=0;     // 0= adressage EEPROM
        Delay_ms(1);
        EECON1.CFGS=0;      // 0= acces data EEPROM
        EECON1.RD=1;        // arme Lecture EEprom
        Delay_ms(20);;
        return(EEDATA);
}

void EEPROM_Ecr(unsigned int AdrE,unsigned char car) // ecrit  a l'adresse adrE
{int dr=0;
    EEADR =AdrE & 0xFF;
    EEADRH = (AdrE>>8)& 0x03;   //Bits 2-7 are masked off since EEPROM is only 1KB
        EEDATA=car;
        EECON1.EEPGD=0;
        EECON1.WREN=1;            // autorise ecriture EEPROM
        EECON1.CFGS =0;
  if(INTCON.GIE ==1)
    {
    INTCON.GIE =0 ;
    dr=1;
    }
        EECON2=0x55;
        EECON2=0xAA;
        EECON1.WR=1;
        while (PIR2.EEIF==0);
        PIR2.EEIF=0;
        EECON1.WREN=0;
        if (dr==1)INTCON.GIE =1;
}

void Save_Msg_To_EEPROM(unsigned int adrx, unsigned char * ptr1)
{
        while (*ptr1) EEPROM_Ecr(adrx++,*ptr1++);
}

void PrintOut_Eeprom_Msg(unsigned int PtrE)
{ unsigned char c;
  do
  {
  if ( PtrE >1023) break;
  c = EEPROM_Lect(PtrE);
  if ( c==0) break;
  UART1_Write(c);
  PtrE++;
  }
  while (c!=0)  ;
 Delay_ms(100);
}

void RAZ_PIC_EEPROM()
{
   // blanchit EEPROM
   for(k=0;k<1023;k++)
   {
    EEPROM_Ecr(k,0x20); // ecrit " " (space) a l'adresse adrE
   }
 }

void Relit_PIC_Eeprom()
{
unsigned int i,ind,dr;
char c1;
if(GIE_bit==1) dr=1;
INTCON.GIE =0 ;  // inhibe globale des IT
i=(unsigned int)EEPROM_Lect(0)<< 8 ;
ind = i +(unsigned int)EEPROM_Lect(1);
k=sprintf(txt,"Lecture Eeprom PIC  Ix=%05d\r\n",ind);
UART1_Write_Text(txt);
k=sprintf(txt,"Nb_Watt;Temp_ext;Nb_Chauffes\r\n");
UART1_Write_Text(txt);
if (ind>1023)     return;
for (i=2;i<ind;i++)
{
   c1=EEPROM_Lect(i);
   UART1_Write(c1);
}
CRLF1();
// annule la commande
if(buffer1[0]=='L')
{
 buffer1[0]=0;
 CptErr=0;
 Drapeaux.Full=0;
 PIE1.RCIE = 1;
 i1=0;
}
if(dr==1)  INTCON.GIE =1 ;  // autorisation globale des IT
}
#endif


 // *******************************************

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}
 
unsigned char *Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 unsigned char *adpt;
 int ie, i, k, ndig;
 double y;
 adpt=str;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
return (adpt);
} 



// ***********************

void redirige_RS232(int wcr, unsigned char *T)
 {
   Drapeaux.Lcd=0; //outmode=0;
  Write_String(T);
  if (wcr==1)
   {
   UART1_Write(10);
  UART1_Write(13);
   }
   Drapeaux.Lcd=1; //outmode=1;
 }

void Write_String(unsigned char *T)
{
short int i1,j1,k;
 j1=strlen(T);
   i1=0;
   do
   {
   k=T[i1];
   if (Drapeaux.Lcd==0)
      UART1_Write(k);
   else  
      sendchar(k);
   i1++;
   }while (i1<j1);
}
 void CRLF1()
 {
 UART1_Write(13);
 UART1_Write(10);
 }

// --- Copie le texte point en ROM  vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source) {
  while (*source)
  {*dest = *source ;
    dest ++  ;
    source ++;
  }  
  *dest = 0 ;    // terminateur
}

void My_ADC_Init()       // for 18F4685
{
  ADCON0=0;     // channel 0 AN0 selected
  ADCON0.ADON=1;
  ADCON1 = 0x1B;
  ADCON1.VCFG1=0;   // -Vref =VSS
  ADCON1.VCFG0=1;   // +Vref= AN3
  //1011 D D D D D D D A A A A
  ADCON1.PCFG3= 1;
  ADCON1.PCFG2= 0;
  ADCON1.PCFG1= 1;
  ADCON1.PCFG0= 1;
  // Right justified
  ADCON2.ADFM=1;
  // 16 TAD
  ADCON2.ACQT2=1;
  ADCON2.ACQT1=1;
  ADCON2.ACQT0=0;
   // FOSC/16
  ADCON2.ADCS2=1;
  ADCON2.ADCS1=0;
  ADCON2.ADCS0=1;
}


unsigned int My_ADC_Read(unsigned char channel)
{
  int i; 
  unsigned int RawM, avg_output=0,temp=0 ;
  if(channel > 7) return 0; 
  ADCON0 =ADCON0 & 0x03;        // AND= RAZ channel selection
  ADCON0 =ADCON0 | channel<<2; // OR = Set  chanel selection
  Delay_ms(3);
  GO_bit = 1;
   _asm NOP  //  allways one instruction after setting bit GO  (MicroChip recommandation)
    while(GO_bit);  // Wait until conversion gets over
     RawM=(unsigned int) (ADRESH<<8) + ADRESL ;   // Store 10-bit output into a 16-bit variable
return(RawM);
}

 void Init_Timer0()
 {
 T0CON         = 0x85;
  TMR0H         = 0x67;
  TMR0L         = 0x69;
  GIE_bit         = 1;
  TMR0IE_bit         = 1;
  }



#ifdef Use_Timer1   
void Init_Timer1(void)    
 {
  T1CON=0;
 // T1CON=0b00110000; 
  TMR1CS_bit=0;   // FOSC /4 internal clock .. page 52
  T1CKPS1_bit=1;  //prescal select=11 => 1/8
  T1CKPS0_bit=1;
  //TMR1H= 0x0B; // Hi (3035);  // init  100mS at 20Mhz
  //TMR1L= 0xDB; // Lo (3035);
   TMR1H= (3035 >> 8);
  TMR1L= (3035 & 0x00FF); 
  PIR1.TMR1IF=0;     // Reset Timer1 Flag
  PIE1.TMR1IE=0;  //Enable interrupt TMR1
  TMR1ON_bit=0;
} 
#endif  



void main()
{

 PORTB = 0x00;           // set PORTB to FF
 TRISB = 0xFD;        // designate portb pins as input except RB2 as output
 TRISB.F1 = 1;        // entree Init RTC par defaut
 PORTA = 0xFF;
 TRISA = 0xFF;          // PORTA is RA0,1,2,3,4,5=input
 TRISD=0x00; // all outputs
  
 PORTC = 0xFE;       // set PORTC to $FF
 TRISC = 0xC0;          // designate PORTC pins as output
 TRISE=0;
 PORTE=0xFF;
 LedBlanche=1;
   
 // portA A0 A1 analog
 // AN2=-Vref=0 ou 3,0V An3=+ref=4.096V   RA5,RE0,RE1,RE2 digitals,
 My_ADC_Init();
  
 Drapeaux.Lcd=0; //outmode=RS232;
 Delay_ms(200);
 LedBlanche=0;
   
 UART1_Init(57600);   // RS232     was 19200 at 10Mhz
 Delay_ms(500);
 UART1_Write(CLS);
 Delay_ms(100);
 CRLF1();
 
 UART1_Write_CText( "Mikroc Pro 6.62\r\n");
 UART1_Write_CText(" Projet : 18F4685_Platine_Nokia_Test_BMP_2016_40Mhz.mcppi.\r\n");
 UART1_Write_CText( "Platine Nokia  PIC 18F4685  "Version"\r\n");
 UART1_Write_CText( "Nokia LCD 96x64 pixels \r\n");
 txt=&TEXTE[0];
 
 // problemo avc TinyBootloader : L'eeprom est limite en taille 256 maxi
 // donc ne charge pas  au dela pour EEPROM de 1024
  UART1_Write_CText("Attention : Tinybootloader V1.98  limite EEPROM  256 bytes ! not 1024 \r\n  ");
  UART1_Write_CText("Lecture 16 bytes PIC EEPROM  :  ");
  for (i=0;i<16;i++)
 {
  CRam1[i]= EEPROM_Lect(i) ;
  Delay_ms(20);
  }
 CRam1[16]=0;
 UART1_Write_Text(CRam1);
 CRLF1();

  UART1_Write_CText("Vecteur Start Bootloader en  0x17F38=  ");
//;Address Opcode         ASM
//0x0000        0xF02EEF57          GOTO        23726
   for (i=0;i<4;i++)
  { 
    c1=FLASH_Read(0x17F38+i);
    ByteToHex(c1,txt);
    UART1_Write_Text(txt);
   }
   CRLF1();
   c1= FLASH_Read(0x17F38+2);
 //  ByteToHex(c1,txt);
//   UART1_Write_Text(txt);
  c2= FLASH_Read(0x17F38);
  k=(int) c1 << 8 ;
  k=k  + c2;
  k=k<<1;
 // WordToHex(k,CRam1);
 // UART1_Write_Text(CRam1);
 // CRLF1();
  sprintf(txt, "Adresse point d'entree Prg MikroC = %x%x h mutiplie 2\
   soit %04X  ou % 5u decimal \r\n" ,(int)c1,(int)c2,k,k);
  UART1_Write_Text(txt);
  LedBlanche=1;
  txt=&TEXTE[0];
  CRam=&CRam1[0];

  L=Get_Fosc_kHz();
  UART1_Write_CText("Freq kHz= ");
  LongToStr(L, CRam1);
  UART1_Write_Text(CRam1);
  CRLF1();

 initlcd();       // Nokia LCD 3310
 Delay_ms(300);
 Drapeaux.Lcd=1; //outmode=Nokia;


 // ------- Presentation  --------
  gotoxy(0,1);
 strConstRamCpy(txt, (const code char *)"Mikroc Pro 6.62");
 Write_String(txt);        // sur LCD
 redirige_RS232(1,txt);
 gotoxy(0,2);
 strConstRamCpy(txt,(const code char *)"Platine 18F4685 ");
 Write_String(txt);
 redirige_RS232(1,txt);
  gotoxy(0,3);
 strConstRamCpy(txt,(const code char *) "With Bootloader.");
 Write_String(txt);
 redirige_RS232(1,txt);
 gotoxy(0,4);
 strConstRamCpy (txt,(const code char *)  "Paulfjujo@freefr");
 Write_String(txt);
 redirige_RS232(1,txt);

 Delay_ms(5000);
  
 #ifdef Test_Timer2
 UART1_Write_CText("\n\r Init Timer2\r\n "); 
 Init_Timer2() ;
 #endif
 
 #ifdef Use_Timer1
 Init_Timer1();
 #endif

  CRLF1();
  i1=0;
  Index1=0;
  buffer1[0]=0;
  txt=TEXTE;

  Drapeaux.See=0;
  Drapeaux.Lcd=1; //outmode=Nokia;
  Nokia_Clean_Ram();

  while(1)
  {
  UART1_Write_CText("Test Sinus avec Print Ram Video  \r\n");
  Nokia_Clean_Ram();
  Nokia_Raz_Ram_Video();
  for (i=0;i<96;i++)  Nokia_Put_Pixel(i,32+(int)(sin((i+j)*3.14159/30)*30),1) ;
  Nokia_Print_Ram_Video();
  Delay_ms(5000);
  

  UART1_Write_CText("Test quadrillage  \r\n");
  Nokia_Clean_Ram();
  Nokia_Raz_Ram_Video();
   for (i=0;i<65;i=i+8)   Nokia_Line(0,i,96,i,1);
   for (i=0;i<96;i=i+12)   Nokia_Line(i,0,i,64,1);
  Nokia_Print_Ram_Video();
  Delay_ms(5000);
  Nokia_Raz_Ram_Video();

 
   UART1_Write_CText("Test BAD avec Bitmap issu de GLCD_Bitmap_editor : mikroE96x64_bmp  \r\n");
  Nokia_Clean_Ram();
  Nokia_Raz_Ram_Video();
  Nokia_Image_96x64(mikroE96x64_bmp);
  Nokia_Print_Ram_Video();
  //Nokia_Affiche_Ram_Video();
  Delay_ms(5000);
  
  
   UART1_Write_CText("Test avec Bitmap image issue de Paintuino.exe :image_MikroE96x64 \r\n");
     Nokia_Clean_Ram();
  Nokia_Raz_Ram_Video();
    Nokia_Image_96x64(image_MikroE96x64);
      Nokia_Print_Ram_Video();
     Delay_ms(5000);
     
   UART1_Write_CText("Test avec Bitmap issu de Paintuino.exe:  MikroC_Everywhere_96x64 \r\n");
   Nokia_Clean_Ram();
  Nokia_Raz_Ram_Video();
    Nokia_Image_96x64( MikroC_Everywhere_96x64);
      Nokia_Print_Ram_Video();
     Delay_ms(5000);
     
     UART1_Write_CText("Test avec Bitmap issu de Paintuino.exe: paulfjujo_1bit \r\n");
       Nokia_Clean_Ram();
     Nokia_Raz_Ram_Video();
    Nokia_Image_96x64( paulfjujo_1bit);
      Nokia_Print_Ram_Video();
     Delay_ms(5000);

  }  // while
}